Subject: Re: [TLS] Questions about TLS Server Name Indication extension

From: <[email-masked]>
Date: Fri, 6 Nov 2009 10:40:17 +0100

Michael D'Errico wrote:

> But that brings up a subtle point.  What if the client originally
> connected offering a higher version than I support?  When it tries
> to resume a session, should it use the version it originally sent
> in the ClientHello, or the lower version that was negotiated?
> 
> I would think that the client should be allowed to specify the same
> version number it originally connected with.
> 
> I searched through RFC 5246 but could not find a discussion of this.
> Did I miss it?  What do others think should happen?

RFC 5246 does say:

   Whenever a client already knows the highest protocol version known to
   a server (for example, when resuming a session), it SHOULD initiate
   the connection in that native protocol.

"SHOULD" seems to allow both cases (and since the server might fall
back to full handshake, perhaps it would be better to send the
highest version supported by the client...).

Best regards,
Pasi